package com.glxp.mipsdl.service.yb;

import cn.hsa.zephyr.apisdk.ZephyrMedicalClient;
import cn.hsa.zephyr.apisdk.internal.exception.ZephyrApiException;
import cn.hsa.zephyr.apisdk.internal.util.encrypt.EncryptionModeEnum;
import cn.hsa.zephyr.apisdk.internal.util.encrypt.SignTypeEnum;
import cn.hsa.zephyr.apisdk.request.ZephyrMedicalRequest;
import cn.hsa.zephyr.apisdk.response.ChsMedicalResponse;
import com.alibaba.fastjson2.JSONObject;
import com.glxp.mipsdl.entity.system.ThrYbSetup;
import com.glxp.mipsdl.service.system.ThrYbSetupService;
import com.glxp.mipsdl.util.DateUtil;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;

@Service
public class YbClient {

    @Resource
    ThrYbSetupService thrYbSetupService;

    public ChsMedicalResponse ybPost(String apiNo, String data) {


        ThrYbSetup thrYbSetup = thrYbSetupService.getSetUp();
        if (thrYbSetup == null)
            throw new RuntimeException("未配置医保接口");
        String infno = apiNo;
        SignTypeEnum signType = SignTypeEnum.SM3;
        EncryptionModeEnum encType = EncryptionModeEnum.SM4;
        String msgId = thrYbSetup.getFixmedins_code() + DateUtil.formatYbDateTime(new Date()) + "0001";
        try {
            ZephyrMedicalClient client = new ZephyrMedicalClient(thrYbSetup.getUrl(), infno, thrYbSetup.getAppId(), thrYbSetup.getAppSecret(),
                    signType, thrYbSetup.getSignKey(), encType, thrYbSetup.getEncKey());
            ZephyrMedicalRequest req = new ZephyrMedicalRequest();
            req.setMsgid(msgId);
            req.setMdtrtAreaAdmdvs(thrYbSetup.getMdtrtarea_admvs());
            req.setInsuplcAdmdvs(thrYbSetup.getInsuplc_admdvs());
            req.setOpter(thrYbSetup.getOpter());
            req.setOpterType(thrYbSetup.getOpter_type());
            req.setOpterName(thrYbSetup.getOpter_name());
            req.setInfTime(DateUtil.formatDateTime(new Date()));
            req.setFixmedinsCode(thrYbSetup.getFixmedins_code());
            req.setFixmedinsName(thrYbSetup.getFixmedins_name());
            com.alibaba.fastjson.JSONObject yyyy = JSONObject.parseObject(data, com.alibaba.fastjson.JSONObject.class);
            req.setInput(yyyy);
            ChsMedicalResponse resp = client.execute(req);
            return resp;
        } catch (ZephyrApiException e) {
            e.printStackTrace();
        }
        return null;
    }

}
